<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Seo Cross Linking Hyva Compatibility
 */

namespace Amasty\CrossLinksHyva\Plugin\CrossLinks\Model\Link;

use Hyva\Theme\Service\CurrentTheme;
use Amasty\CrossLinks\Model\Link;

class SetLinkAdditionalClass
{
    private const LINK_REPLACEMENT = '<a class="am-crosslink" ';

    /**
     * @var CurrentTheme
     */
    private $currentTheme;

    public function __construct(
        CurrentTheme $currentTheme
    ) {
        $this->currentTheme = $currentTheme;
    }

    /**
     * @param $subject
     * @param string $result
     * @return string
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterGetLinkHtml(Link $subject, string $result): string
    {
        if (!$this->currentTheme->isHyva()) {
            return $result;
        }

        return $this->addLinkClasses($result);
    }

    private function addLinkClasses(string $result): string
    {
        return str_replace('<a ', self::LINK_REPLACEMENT, $result);
    }
}
