<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Seo Cross Linking Hyva Compatibility
 */

namespace Amasty\CrossLinksHyva\Plugin\Hyva\Theme\ViewModel\ProductAttributes;

use Amasty\CrossLinksHyva\Model\SkipFlag;
use Hyva\Theme\ViewModel\ProductAttributes;
use Magento\Catalog\Api\Data\ProductAttributeInterface;
use Magento\Catalog\Api\Data\ProductInterface;

class SetSkipFlag
{
    /**
     * @var SkipFlag
     */
    private $skipFlag;

    public function __construct(
        SkipFlag $skipFlag
    ) {
        $this->skipFlag = $skipFlag;
    }

    /**
     * @param ProductAttributes $subject
     * @param ProductAttributeInterface $attribute
     * @param ProductInterface $product
     * @return array
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function beforeGetAttributeData(
        ProductAttributes $subject,
        ProductAttributeInterface $attribute,
        ProductInterface $product
    ): array {
        $this->skipFlag->setSkip(true);

        return [$attribute, $product];
    }

    /**
     * @param ProductAttributes $subject
     * @param array $result
     * @return array
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function afterGetAttributeData(ProductAttributes $subject, array $result): array
    {
        $this->skipFlag->setSkip(false);

        return $result;
    }
}
